Index: trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1067)
+++ trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1084)
@@ -915,5 +915,5 @@
         }
         m_pcEntropyCoder->encodeSkipFlag( pcCU, 0, true );
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
         m_pcEntropyCoder->encodeSingleDepthMode(pcCU, 0, true );
         if(!pcCU->getSingleDepthFlag(uiAbsPartIdx))
@@ -921,5 +921,5 @@
         m_pcEntropyCoder->encodePredMode( pcCU, 0, true );
       }
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
       else
       {
@@ -927,5 +927,5 @@
       }
 #endif      
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
       if(!pcCU->getSingleDepthFlag(uiAbsPartIdx))
       {
@@ -945,9 +945,9 @@
         }
       }
-#if MTK_SINGLE_DEPTH_MODE_I0095
-    }
-#endif
-    }
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
+    }
+#endif
+    }
+#if H_3D_SINGLE_DEPTH
       if(!pcCU->getSingleDepthFlag(uiAbsPartIdx))
       {
@@ -995,5 +995,5 @@
     }
   }
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
     }
 #endif
@@ -1859,5 +1859,5 @@
   dRDCost  += dSingleCost;
 }
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
 Void TEncSearch::xIntraCodingSingleDepth( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist& ruiDist, Double& dRDCost, Int iTestDepthIdx, Pel *DepthNeighbor )
 {
@@ -1970,16 +1970,8 @@
       UInt dimType   = getDimType  ( uiLumaPredMode );
       UInt patternID = pcCU->getDmmWedgeTabIdx(dimType, uiAbsPartIdx);
-#if SHARP_DMM1_I0110
       UInt uiBaseWidth = pcCU->isDMM1UpscaleMode(uiWidth) ? pcCU->getDMM1BasePatternWidth(uiWidth) : uiWidth;
       if ( patternID >= g_dmmWedgeLists[g_aucConvertToBit[uiBaseWidth]].size() && dimType == DMM1_IDX )
-#else
-      if ( patternID >= g_dmmWedgeLists[g_aucConvertToBit[uiWidth]].size() && dimType == DMM1_IDX )
-#endif
-      {
-#if SHARP_DMM1_I0110
+      {
         if (g_aucConvertToBit[uiBaseWidth] == 2) // Encoder method. Avoid DMM1 pattern list index exceeds the maximum DMM1 pattern number when SDC split is used.
-#else
-        if (g_aucConvertToBit[uiWidth] == 2) // Encoder method. Avoid DMM1 pattern list index exceeds the maximum DMM1 pattern number when SDC split is used.
-#endif
         {                                    
           patternID = 1349;  // Split 32x32 to 16x16. 1349: Maximum DMM1 pattern number when block size is 16x16
@@ -2043,19 +2035,10 @@
     Int uiTabIdx = pcCU->getDmmWedgeTabIdx(DMM1_IDX, uiAbsPartIdx);
 
-#if SHARP_DMM1_I0110
     WedgeList* pacWedgeList  = pcCU->isDMM1UpscaleMode( uiWidth ) ? &g_dmmWedgeLists[(g_aucConvertToBit[pcCU->getDMM1BasePatternWidth(uiWidth)])] : &g_dmmWedgeLists[(g_aucConvertToBit[uiWidth])];
-#else
-    WedgeList* pacWedgeList = &g_dmmWedgeLists[(g_aucConvertToBit[uiWidth])];
-#endif
     TComWedgelet* pcWedgelet = &(pacWedgeList->at( uiTabIdx ));
 
     uiNumSegments = 2;
-#if SHARP_DMM1_I0110
     pbMask       = pcCU->isDMM1UpscaleMode( uiWidth ) ? pcWedgelet->getScaledPattern( uiWidth ) : pcWedgelet->getPattern();
     uiMaskStride = pcCU->isDMM1UpscaleMode( uiWidth ) ? uiWidth : pcWedgelet->getStride();
-#else
-    pbMask = pcWedgelet->getPattern();
-    uiMaskStride = pcWedgelet->getStride();
-#endif
   }
   if( getDimType( uiLumaPredMode ) == DMM4_IDX )
@@ -2878,5 +2861,5 @@
   pcCU->setChromIntraDirSubParts( uiBestMode, 0, pcCU->getDepth( 0 ) );
 }
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
 Void 
 TEncSearch::estIntraPredSingleDepth( TComDataCU* pcCU, 
@@ -2900,5 +2883,5 @@
   Pel DepthNeighbours[5];
   //construction of depth candidates
-  for( Int i = 0; (i < 5)  && (index<MTK_SINGLE_DEPTH_MODE_CANDIDATE_LIST_SIZE) ; i++ )
+  for( Int i = 0; (i < 5)  && (index<SINGLE_DEPTH_MODE_CAND_LIST_SIZE) ; i++ )
   {
     if(!pcCU->getNeighDepth (0, 0, &testDepth, i))
@@ -2983,5 +2966,5 @@
                             UInt&       ruiDistC,
                             Bool        bLumaOnly
-#if HHI_DMM4_ENC_I0066
+#if H_3D_DIM
                           , Bool        bOnlyIVP
 #endif
@@ -3032,5 +3015,5 @@
     Int numModesForFullRD = g_aucIntraModeNumFast[ uiWidthBit ];
     
-#if HHI_DMM4_ENC_I0066
+#if H_3D_DIM
     if( bOnlyIVP )
     {
@@ -3080,5 +3063,4 @@
         UInt   iModeBits = xModeBitsIntra( pcCU, uiMode, uiPU, uiPartOffset, uiDepth, uiInitTrDepth );
 #if H_3D_VSO // M35
-#if H_3D_VSO_FIX // This fix should be enabled after verification 
         Double dLambda;
         if ( m_pcRdCost->getUseLambdaScaleVSO() )
@@ -3092,7 +3074,4 @@
 
         Double cost      = (Double)uiSad + (Double)iModeBits * dLambda;
-#else
-        Double cost      = (Double)uiSad + (Double)iModeBits * m_pcRdCost->getSqrtLambda();
-#endif
 #else
         Double cost      = (Double)uiSad + (Double)iModeBits * m_pcRdCost->getSqrtLambda();
@@ -3135,5 +3114,5 @@
       }
     }
-#if HHI_DMM4_ENC_I0066
+#if H_3D_DIM
     }
 #endif
@@ -3143,10 +3122,5 @@
     if( m_pcEncCfg->getIsDepth() && uiWidth >= DIM_MIN_SIZE && uiWidth <= DIM_MAX_SIZE && uiWidth == uiHeight )
     {
-#if HHI_DMM4_ENC_I0066
-#if SEPARATE_FLAG_I0085
       if( bOnlyIVP && m_pcEncCfg->getUseIVP() )
-#else
-      if( bOnlyIVP )
-#endif
       {
         TComWedgelet* dmm4Segmentation = new TComWedgelet( uiWidth, uiHeight );
@@ -3158,16 +3132,9 @@
         pcCU->setDimDeltaDC( DMM4_IDX, 1, uiPartOffset, deltaDC2 );
 
-#if HS_DMM_SIGNALLING_I0120
         uiRdModeList[ numModesForFullRD++ ] = (DMM4_IDX+DIM_OFFSET);
-#else
-        uiRdModeList[ numModesForFullRD++ ] = (2*DMM4_IDX  +DIM_OFFSET);
-        if( deltaDC1 != 0 || deltaDC2 != 0 )
-          uiRdModeList[ numModesForFullRD++ ] = (2*DMM4_IDX+1+DIM_OFFSET);
-#endif
         dmm4Segmentation->destroy(); delete dmm4Segmentation;
       }
       else
       {
-#endif
 #if H_3D_FAST_DEPTH_INTRA
       Int  threshold    = max(((pcCU->getQP(0))>>3)-1,3);
@@ -3177,9 +3144,5 @@
 
 #if H_3D_DIM_DMM
-#if SEPARATE_FLAG_I0085
       if( ( m_pcEncCfg->getUseDMM() || m_pcEncCfg->getUseIVP() )
-#else
-      if( m_pcEncCfg->getUseDMM()
-#endif
 #if H_3D_FAST_DEPTH_INTRA
          && (uiRdModeList[0] != PLANAR_IDX || varCU >= varThreshold)
@@ -3187,5 +3150,4 @@
         )
       {
-#if SEPARATE_FLAG_I0085
         UInt uiStart, uiEnd;
         if( m_pcEncCfg->getUseDMM() &&  m_pcEncCfg->getUseIVP() )
@@ -3210,11 +3172,8 @@
         }
         for( UInt dmmType = uiStart; dmmType < uiEnd; dmmType++ )
-#else
-        for( UInt dmmType = 0; dmmType < DMM_NUM_TYPE; dmmType++ )
-#endif
         {
 #if H_3D_FCO
             TComPic* picTexture  = pcCU->getSlice()->getIvPic(false, pcCU->getSlice()->getViewIndex() );
-#if LGE_FCO_I0116
+#if H_3D_FCO
             if ( !picTexture->getReconMark() && (DMM4_IDX == dmmType ) )
 #else
@@ -3234,10 +3193,6 @@
               xSearchDmm1Wedge( pcCU, uiPartOffset, piOrg, uiStride, uiWidth, uiHeight, uiTabIdx );
               pcCU->setDmmWedgeTabIdxSubParts( uiTabIdx, dmmType,  uiPartOffset, uiDepth + uiInitTrDepth );
-#if SHARP_DMM1_I0110
               biSegmentation = pcCU->isDMM1UpscaleMode( uiWidth ) ? 
                   &(g_dmmWedgeLists[(g_aucConvertToBit[pcCU->getDMM1BasePatternWidth(uiWidth)])][uiTabIdx]) : &(g_dmmWedgeLists[(g_aucConvertToBit[uiWidth])][uiTabIdx]);
-#else
-              biSegmentation = &(g_dmmWedgeLists[(g_aucConvertToBit[uiWidth])][uiTabIdx]);
-#endif
             } break;
 
@@ -3254,5 +3209,4 @@
           if( biSegmentation )
           {
-#if SHARP_DMM1_I0110
             if( dmmType == DMM1_IDX && pcCU->isDMM1UpscaleMode( uiWidth ) ){
                 xSearchDmmDeltaDCs( pcCU, uiPartOffset, piOrg, piPred, uiStride, biSegmentation->getScaledPattern(uiWidth), uiWidth, uiWidth, uiHeight, deltaDC1, deltaDC2 );
@@ -3262,25 +3216,13 @@
                 xSearchDmmDeltaDCs( pcCU, uiPartOffset, piOrg, piPred, uiStride, biSegmentation->getPattern(), biSegmentation->getStride(), uiWidth, uiHeight, deltaDC1, deltaDC2 );
             }
-#else
-            xSearchDmmDeltaDCs( pcCU, uiPartOffset, piOrg, piPred, uiStride, biSegmentation->getPattern(), biSegmentation->getStride(), uiWidth, uiHeight, deltaDC1, deltaDC2 );
-#endif
             pcCU->setDimDeltaDC( dmmType, 0, uiPartOffset, deltaDC1 );
             pcCU->setDimDeltaDC( dmmType, 1, uiPartOffset, deltaDC2 );
 
-#if HS_DMM_SIGNALLING_I0120
             uiRdModeList[ numModesForFullRD++ ] = (dmmType  +DIM_OFFSET);
-#else
-            uiRdModeList[ numModesForFullRD++ ] = (2*dmmType  +DIM_OFFSET);
-#if HHI_DMM4_ENC_I0066
-            if( deltaDC1 != 0 || deltaDC2 != 0 )
-#endif
-            uiRdModeList[ numModesForFullRD++ ] = (2*dmmType+1+DIM_OFFSET);
-#endif
-
             if( DMM4_IDX == dmmType ) { biSegmentation->destroy(); delete biSegmentation; }
           }
         }
       }
-#if HHI_DMM4_ENC_I0066
+#if H_3D_DIM
       }
 #endif
@@ -3295,5 +3237,5 @@
     
     UInt    uiBestPUMode  = 0;
-#if SCU_HS_FAST_INTRA_SDC_I0123
+#if H_3D_FAST_INTRA_SDC
     UInt    uiBestPUModeConv  = 0;
     UInt    uiSecondBestPUModeConv  = 0;
@@ -3309,5 +3251,5 @@
     Double  dBestPUCost   = MAX_DOUBLE;
 
-#if SCU_HS_FAST_INTRA_SDC_I0123
+#if H_3D_FAST_INTRA_SDC
     Double  dBestPUCostConv   = MAX_DOUBLE;
     UInt varCU      = m_pcRdCost->calcVAR(piOrg, uiStride, uiWidth,uiHeight,pcCU->getDepth(0));
@@ -3319,5 +3261,5 @@
     Pel     apBestDCOffsets[2] = {0,0};
 #endif
-#if SCU_HS_FAST_INTRA_SDC_I0123
+#if H_3D_FAST_INTRA_SDC
     for( UInt uiMode = 0; uiMode < numModesForFullRD + rdSDC; uiMode++ )
 #else
@@ -3326,9 +3268,9 @@
     {
       // set luma prediction mode
-#if !SCU_HS_FAST_INTRA_SDC_I0123
+#if !H_3D_FAST_INTRA_SDC
      UInt uiOrgMode = uiRdModeList[uiMode];  
 #endif
       
-#if SCU_HS_FAST_INTRA_SDC_I0123
+#if H_3D_FAST_INTRA_SDC
       UInt uiOrgMode;
       if (uiMode < numModesForFullRD)
@@ -3356,5 +3298,5 @@
       
 #if H_3D_DIM_SDC
-#if SCU_HS_FAST_INTRA_SDC_I0123
+#if H_3D_FAST_INTRA_SDC
       Bool bTestSDC = ( m_pcEncCfg->getUseSDC() && pcCU->getSDCAvailable(uiPartOffset) && uiMode >= numModesForFullRD);
 #else
@@ -3364,16 +3306,11 @@
       for( UInt uiSDC=0; uiSDC<=(bTestSDC?1:0); uiSDC++ )
       {
-#if SCU_HS_FAST_INTRA_SDC_I0123
+#if H_3D_FAST_INTRA_SDC
         if (!uiSDC && uiMode >= numModesForFullRD) continue;
 #endif
         pcCU->setSDCFlagSubParts( (uiSDC != 0), uiPartOffset, uiDepth + uiInitTrDepth );
-#if FAST_SDC_OFFSET_DECISION_I0084
         Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
         for( Int iOffset = 1; iOffset <= 5; iOffset++ )
-#else
-        for( Int iSDCDeltaResi = -2; iSDCDeltaResi <= 2; iSDCDeltaResi++ )
-#endif
-        {
-#if FAST_SDC_OFFSET_DECISION_I0084
+        {
           Int iSDCDeltaResi = 0;
           if(iOffset % 2 == 0)
@@ -3385,10 +3322,8 @@
             iSDCDeltaResi = -1 * (iOffset >> 1);
           }
-#endif
           if( ( uiSDC == 0 ) && iSDCDeltaResi != 0 )
           {
             continue;
           }
-#if FAST_SDC_OFFSET_DECISION_I0084
           if( iOffset > 3)
           {
@@ -3407,5 +3342,4 @@
           }
 #endif
-#endif
       
 #if H_3D_DIM_ENC || H_3D_DIM_SDC
@@ -3452,10 +3386,8 @@
           // start encoding with SDC
           xIntraCodingSDC(pcCU, uiPartOffset, pcOrgYuv, pcPredYuv, uiPUDistY, dPUCost, ( testZeroResi != 0 ), iSDCDeltaResi );
-#if FAST_SDC_OFFSET_DECISION_I0084
           if ( testZeroResi == 0 && iOffset <= 3 )
           {
             dOffsetCost [iOffset -1] = dPUCost;
           }
-#endif
         }
         else
@@ -3465,5 +3397,5 @@
 #if H_3D_DIM_ENC
           xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, true, dPUCost, (testZeroResi != 0) );
-#if SCU_HS_FAST_INTRA_SDC_I0123    
+#if H_3D_FAST_INTRA_SDC    
       if( dPUCost < dBestPUCostConv )
       {
@@ -4017,7 +3949,4 @@
 #if H_3D_VSP
                                  , Int* vspFlag
-#if !FIX_TICKET_79
-                                 , InheritedVSPDisInfo*  inheritedVSPDisInfo
-#endif
 #endif
 #if H_3D_SPIVMP
@@ -4079,7 +4008,4 @@
       pcCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours, numValidMergeCand);
       pcCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours
-#if H_3D_VSP && !FIX_TICKET_79
-                                        , inheritedVSPDisInfo
-#endif
 #if H_3D_SPIVMP
         , pcMvFieldSP, puhInterDirSP
@@ -4109,7 +4035,4 @@
     pcCU->getInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours,uhInterDirNeighbours, numValidMergeCand);
     pcCU->xGetInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours
-#if H_3D_VSP && !FIX_TICKET_79
-                                      , inheritedVSPDisInfo
-#endif
 #if H_3D_SPIVMP
       , pcMvFieldSP, puhInterDirSP
@@ -4132,9 +4055,5 @@
 #endif
   }
-#if H_3D_VSP && !FIX_TICKET_75
-  xRestrictBipredMergeCand( pcCU, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours,vspFlag, numValidMergeCand );
-#else
   xRestrictBipredMergeCand( pcCU, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
-#endif
 
 #if H_3D_DBBP
@@ -4164,7 +4083,4 @@
 #if H_3D_VSP
     pcCU->setVSPFlagSubParts( vspFlag[uiMergeCand], uiAbsPartIdx, iPUIdx, pcCU->getDepth( uiAbsPartIdx ) );
-#if !FIX_TICKET_79
-    pcCU->setDvInfoSubParts(inheritedVSPDisInfo[uiMergeCand].m_acDvInfo, uiAbsPartIdx, iPUIdx, pcCU->getDepth( uiAbsPartIdx ) );
-#endif
 #endif
 
@@ -4266,9 +4182,5 @@
  * \returns Void
  */
-#if H_3D_VSP && !FIX_TICKET_75
-Void TEncSearch::xRestrictBipredMergeCand( TComDataCU* pcCU, UInt puIdx, TComMvField* mvFieldNeighbours, UChar* interDirNeighbours, Int* vspFlag, Int numValidMergeCand )
-#else
 Void TEncSearch::xRestrictBipredMergeCand( TComDataCU* pcCU, UInt puIdx, TComMvField* mvFieldNeighbours, UChar* interDirNeighbours, Int numValidMergeCand )
-#endif
 {
   if ( pcCU->isBipredRestriction(puIdx) )
@@ -4276,9 +4188,5 @@
     for( UInt mergeCand = 0; mergeCand < numValidMergeCand; ++mergeCand )
     {
-#if H_3D_VSP && !FIX_TICKET_75
-      if ( (interDirNeighbours[mergeCand] == 3) && (vspFlag[mergeCand] == false) )
-#else
       if ( interDirNeighbours[mergeCand] == 3 )
-#endif
       {
         interDirNeighbours[mergeCand] = 1;
@@ -4902,7 +4810,4 @@
       Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
       memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#if !FIX_TICKET_79
-      InheritedVSPDisInfo inheritedVSPDisInfo[MRG_MAX_NUM_CANDS_MEM];
-#endif
       UInt uiAbsPartIdx = 0;
       Int iWidth = 0;
@@ -4922,7 +4827,4 @@
 #if H_3D_VSP
                       , vspFlag
-#if !FIX_TICKET_79
-                      , inheritedVSPDisInfo
-#endif
 #endif
 #if H_3D_SPIVMP
@@ -4938,7 +4840,4 @@
 #if H_3D_VSP
         pcCU->setVSPFlagSubParts( vspFlag[uiMRGIndex], uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-#if !FIX_TICKET_79
-        pcCU->setDvInfoSubParts(inheritedVSPDisInfo[uiMRGIndex].m_acDvInfo, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-#endif
 #endif
 #if H_3D_DDD
@@ -6430,11 +6329,15 @@
     if( bCodeChroma )
     {
+      m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
+      m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbf   ( pcCU, uiAbsPartIdx, TEXT_CHROMA_U, uiTrMode );
       m_pcEntropyCoder->encodeCoeffNxN( pcCU, pcCoeffCurrU, uiAbsPartIdx, trWidthC, trHeightC, uiDepth, TEXT_CHROMA_U );
-      uiSingleBitsU = m_pcEntropyCoder->getNumberOfWrittenBits() - uiSingleBitsY;
+      uiSingleBitsU = m_pcEntropyCoder->getNumberOfWrittenBits();
       
+      m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
+      m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbf   ( pcCU, uiAbsPartIdx, TEXT_CHROMA_V, uiTrMode );
       m_pcEntropyCoder->encodeCoeffNxN( pcCU, pcCoeffCurrV, uiAbsPartIdx, trWidthC, trHeightC, uiDepth, TEXT_CHROMA_V );
-      uiSingleBitsV = m_pcEntropyCoder->getNumberOfWrittenBits() - ( uiSingleBitsY + uiSingleBitsU );
+      uiSingleBitsV = m_pcEntropyCoder->getNumberOfWrittenBits();
     }
     
@@ -6517,4 +6420,6 @@
         const Double singleCostY = m_pcRdCost->calcRdCost( uiSingleBitsY, uiNonzeroDistY );
 #endif
+        m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
+
         m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbfZero( pcCU, TEXT_LUMA,     uiTrMode );
@@ -6550,4 +6455,5 @@
     else if( checkTransformSkipY )
     {
+      m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
       m_pcEntropyCoder->resetBits();
       m_pcEntropyCoder->encodeQtCbfZero( pcCU, TEXT_LUMA, uiTrMode );
@@ -6606,4 +6512,5 @@
         {
           const Double dSingleCostU = m_pcRdCost->calcRdCost( uiSingleBitsU, uiNonzeroDistU );
+          m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
           m_pcEntropyCoder->resetBits();
           m_pcEntropyCoder->encodeQtCbfZero( pcCU, TEXT_CHROMA_U,     uiTrMode );
@@ -6631,4 +6538,5 @@
       else if( checkTransformSkipUV )
       {
+        m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
         m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbfZero( pcCU, TEXT_CHROMA_U, uiTrMode );
@@ -6675,4 +6583,5 @@
         {
           const Double dSingleCostV = m_pcRdCost->calcRdCost( uiSingleBitsV, uiNonzeroDistV );
+          m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
           m_pcEntropyCoder->resetBits();
           m_pcEntropyCoder->encodeQtCbfZero( pcCU, TEXT_CHROMA_V,     uiTrMode );
@@ -6700,4 +6609,5 @@
       else if( checkTransformSkipUV )
       {
+        m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
         m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbfZero( pcCU, TEXT_CHROMA_V, uiTrMode );
@@ -6896,5 +6806,4 @@
       pcCU->setCbfSubParts( uiAbsSumTransformSkipV ? uiSetCbf : 0, TEXT_CHROMA_V, uiAbsPartIdx, pcCU->getDepth(0)+uiTrModeC );
 
-      m_pcEntropyCoder->resetBits();
       uiSingleBitsU = 0;
       uiSingleBitsV = 0;
@@ -6902,4 +6811,5 @@
       if( uiAbsSumTransformSkipU )
       {
+        m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbf   ( pcCU, uiAbsPartIdx, TEXT_CHROMA_U, uiTrMode );
         m_pcEntropyCoder->encodeCoeffNxN( pcCU, pcCoeffCurrU, uiAbsPartIdx, trWidthC, trHeightC, uiDepth, TEXT_CHROMA_U );
@@ -6944,7 +6854,9 @@
       if( uiAbsSumTransformSkipV )
       {
+        m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[ uiDepth ][ CI_QT_TRAFO_ROOT ] );
+        m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeQtCbf   ( pcCU, uiAbsPartIdx, TEXT_CHROMA_V, uiTrMode );
         m_pcEntropyCoder->encodeCoeffNxN( pcCU, pcCoeffCurrV, uiAbsPartIdx, trWidthC, trHeightC, uiDepth, TEXT_CHROMA_V );
-        uiSingleBitsV = m_pcEntropyCoder->getNumberOfWrittenBits() - uiSingleBitsU;
+        uiSingleBitsV = m_pcEntropyCoder->getNumberOfWrittenBits();
 
         curChromaQpOffset = pcCU->getSlice()->getPPS()->getChromaCrQpOffset() + pcCU->getSlice()->getSliceQpDeltaCr();
@@ -7388,5 +7300,5 @@
     }
     m_pcEntropyCoder->encodeSkipFlag ( pcCU, 0, true );
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
     m_pcEntropyCoder->encodeSingleDepthMode ( pcCU, 0, true );
 #endif
@@ -7845,11 +7757,6 @@
 
   Pel refDC1 = 0; Pel refDC2 = 0;
-#if SHARP_DMM1_I0110
   WedgeList*     pacWedgeList     = pcCU->isDMM1UpscaleMode( uiWidth ) ? &g_dmmWedgeLists[(g_aucConvertToBit[pcCU->getDMM1BasePatternWidth(uiWidth)])] : &g_dmmWedgeLists[(g_aucConvertToBit[uiWidth])];
   WedgeNodeList* pacWedgeNodeList = pcCU->isDMM1UpscaleMode( uiWidth ) ? &g_dmmWedgeNodeLists[(g_aucConvertToBit[pcCU->getDMM1BasePatternWidth(uiWidth)])] : &g_dmmWedgeNodeLists[(g_aucConvertToBit[uiWidth])];
-#else
-  WedgeList*     pacWedgeList     = &g_dmmWedgeLists    [(g_aucConvertToBit[uiWidth])];
-  WedgeNodeList* pacWedgeNodeList = &g_dmmWedgeNodeLists[(g_aucConvertToBit[uiWidth])];
-#endif
 
   // coarse wedge search
@@ -7859,13 +7766,8 @@
   {
     TComWedgelet* pcWedgelet = &(pacWedgeList->at(pacWedgeNodeList->at(uiNodeId).getPatternIdx()));
-#if SHARP_DMM1_I0110
     Bool *pbPattern = pcCU->isDMM1UpscaleMode(uiWidth) ? pcWedgelet->getScaledPattern(uiWidth) : pcWedgelet->getPattern();
     UInt uiStride   = pcCU->isDMM1UpscaleMode(uiWidth) ? uiWidth : pcWedgelet->getStride();
     xCalcBiSegDCs  ( piRef,  uiRefStride,  pbPattern, uiStride, refDC1, refDC2 );
     xAssignBiSegDCs( piPred, uiPredStride, pbPattern, uiStride, refDC1, refDC2 );
-#else
-    xCalcBiSegDCs  ( piRef,  uiRefStride,  pcWedgelet->getPattern(), pcWedgelet->getStride(), refDC1, refDC2 );
-    xAssignBiSegDCs( piPred, uiPredStride, pcWedgelet->getPattern(), pcWedgelet->getStride(), refDC1, refDC2 );
-#endif
 
     Dist uiActDist = RDO_DIST_MAX;
@@ -7903,13 +7805,8 @@
     {
       TComWedgelet* pcWedgelet = &(pacWedgeList->at(pacWedgeNodeList->at(uiBestNodeId).getRefineIdx( uiRefId )));
-#if SHARP_DMM1_I0110
       Bool *pbPattern = pcCU->isDMM1UpscaleMode(uiWidth) ? pcWedgelet->getScaledPattern(uiWidth) : pcWedgelet->getPattern();
       UInt uiStride   = pcCU->isDMM1UpscaleMode(uiWidth) ? uiWidth : pcWedgelet->getStride();
       xCalcBiSegDCs  ( piRef,  uiRefStride,  pbPattern, uiStride, refDC1, refDC2 );
       xAssignBiSegDCs( piPred, uiPredStride, pbPattern, uiStride, refDC1, refDC2 );
-#else
-      xCalcBiSegDCs  ( piRef,  uiRefStride,  pcWedgelet->getPattern(), pcWedgelet->getStride(), refDC1, refDC2 );
-      xAssignBiSegDCs( piPred, uiPredStride, pcWedgelet->getPattern(), pcWedgelet->getStride(), refDC1, refDC2 );
-#endif
       Dist uiActDist = RDO_DIST_MAX;
 #if H_3D_VSO
Index: trunk/source/Lib/TLibEncoder/TEncSearch.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSearch.h	(revision 1067)
+++ trunk/source/Lib/TLibEncoder/TEncSearch.h	(revision 1084)
@@ -181,5 +181,5 @@
                                   UInt&       ruiDistC,
                                   Bool        bLumaOnly
-#if HHI_DMM4_ENC_I0066
+#if H_3D_DIM
                                 , Bool        bOnlyIVP
 #endif
@@ -191,5 +191,5 @@
                                   TComYuv*    pcRecoYuv,
                                   UInt        uiPreCalcDistC );
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
   Void  estIntraPredSingleDepth  ( TComDataCU* pcCU, 
                                   TComYuv*    pcOrgYuv, 
@@ -354,5 +354,5 @@
                                     UInt         uiAbsPartIdx,
                                     UInt         stateU0V1Both2 );
-#if MTK_SINGLE_DEPTH_MODE_I0095
+#if H_3D_SINGLE_DEPTH
   Void xIntraCodingSingleDepth( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist& ruiDist, Double& dRDCost, Int iTestDepthIdx, Pel * DepthNeighbor );
 #endif
@@ -429,7 +429,4 @@
 #if H_3D_VSP
                                   , Int* vspFlag
-#if !FIX_TICKET_79
-                                  , InheritedVSPDisInfo*  inheritedVSPDisInfo
-#endif
 #endif
 #if H_3D_SPIVMP
@@ -443,7 +440,4 @@
                                     TComMvField*    mvFieldNeighbours, 
                                     UChar*          interDirNeighbours, 
-#if H_3D_VSP && !FIX_TICKET_75
-                                    Int* vspFlag,
-#endif
                                     Int             numValidMergeCand );
 
Index: trunk/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1067)
+++ trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1084)
@@ -72,8 +72,6 @@
   ContextModel::buildNextStateTable();
 #endif
-#if H_MV_HLS10_GEN_FIX
 #if H_MV
   m_iNumSubstreams         = 0; 
-#endif
 #endif
 
@@ -89,5 +87,5 @@
   m_ivPicLists = NULL;
 #endif
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086_FIX
+#if H_3D_IC
   m_aICEnableCandidate = NULL;
   m_aICEnableNum = NULL;
@@ -236,5 +234,4 @@
       for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
       {
-#if H_MV_HLS10_GEN_FIX
 #if H_MV
         xDelete( false, m_pppcRDSbacCoder, iDepth, iCIIdx);
@@ -244,5 +241,4 @@
         delete m_pppcBinCoderCABAC[iDepth][iCIIdx];
 #endif
-#endif
       }
     }
@@ -250,5 +246,4 @@
     for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
     {
-#if H_MV_HLS10_GEN_FIX
 #if H_MV
       xDelete( true, m_pppcRDSbacCoder  , iDepth);
@@ -258,8 +253,6 @@
       delete [] m_pppcBinCoderCABAC[iDepth];
 #endif
-#endif
-    }
-
-#if H_MV_HLS10_GEN_FIX
+    }
+
 #if H_MV
      xDelete( true, m_pppcRDSbacCoder  );
@@ -269,5 +262,4 @@
     delete [] m_pppcBinCoderCABAC;
 #endif
-#endif
     for ( UInt ui = 0; ui < m_iNumSubstreams; ui++ )
     {
@@ -276,5 +268,4 @@
         for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
         {
-#if H_MV_HLS10_GEN_FIX
 #if H_MV
           xDelete(false, m_ppppcRDSbacCoders  ,ui, iDepth, iCIIdx);
@@ -284,5 +275,4 @@
           delete m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx];
 #endif
-#endif
         }
       }
@@ -290,5 +280,4 @@
       for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
       {
-#if H_MV_HLS10_GEN_FIX
 #if H_MV
         xDelete(true, m_ppppcRDSbacCoders  ,ui, iDepth);
@@ -298,9 +287,7 @@
         delete [] m_ppppcBinCodersCABAC[ui][iDepth];
 #endif
-#endif
-      }
-
-
-#if H_MV_HLS10_GEN_FIX
+      }
+
+
 #if H_MV
       xDelete(true, m_ppppcRDSbacCoders,   ui);
@@ -310,7 +297,5 @@
       delete[] m_ppppcBinCodersCABAC[ui];
 #endif
-#endif
-    }
-#if H_MV_HLS10_GEN_FIX
+    }
 #if H_MV
     xDelete(true, m_ppppcRDSbacCoders    ) ;
@@ -332,5 +317,4 @@
   delete[] m_pcRdCosts;
 #endif
-#endif
 
 #if !H_MV
@@ -370,5 +354,5 @@
 
   xInitPPSforTiles();
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086_FIX
+#if H_3D_IC
   m_aICEnableCandidate = new Int[ 10 ];
   m_aICEnableNum = new Int[ 10 ];
@@ -769,5 +753,4 @@
 #if H_MV  
   m_cSPS.setUpdateRepFormatFlag           ( false );    
-#if H_MV_HLS10_MULTILAYERSPS  
   Bool multiLayerExtensionFlag  = ( getLayerId() > 0 ) && ( m_cVPS->getNumRefLayers( getLayerId() ) > 0 ); 
   
@@ -778,8 +761,4 @@
     m_cSPS.setSpsScalingListRefLayerId( m_cVPS->getIdRefLayer( getLayerId(), 0 ) ); 
   }
-#else
-  m_cSPS.setSpsInferScalingListFlag       ( m_layerId > 0 && m_cVPS->getInDirectDependencyFlag( getLayerIdInVps(), 0 ) ); 
-  m_cSPS.setSpsScalingListRefLayerId      ( 0              ); 
-#endif
   m_cSPS.setSpsExtensionPresentFlag       ( true ); 
   m_cSPS.setSpsMultilayerExtensionFlag    ( true ); 
@@ -829,11 +808,4 @@
   m_cSPS.setUseAMP ( m_useAMP );
 
-#if !MTK_I0099_VPS_EX2
-#if H_3D_QTLPC
-  m_cSPS.setUseQTL( m_bUseQTL );
-  m_cSPS.setUsePC ( m_bUsePC  );
-#endif
-#endif
-
   for (i = g_uiMaxCUDepth-g_uiAddCUDepth; i < g_uiMaxCUDepth; i++ )
   {
@@ -863,17 +835,10 @@
     for( Int is = 0; is < targetDecLayerIdList.size(); is++  )
     {
-#if H_MV_HLS10_ADD_LAYERSETS
       if ( m_cVPS->getNecessaryLayerFlag( ols, is ) )
       {      
         m_cSPS.inferSpsMaxDecPicBufferingMinus1( m_cVPS, ols, targetDecLayerIdList[is], true );       
       }
-#else
-      m_cSPS.inferSpsMaxDecPicBufferingMinus1( m_cVPS, ols, targetDecLayerIdList[is], true );       
-#endif
-    }
-  }
-#if !H_MV_HLS10_ADD_LAYERSETS 
-  m_cVPS->inferDbpSizeLayerSetZero( &m_cSPS, true ); 
-#endif
+    }
+  }
 #endif
   m_cSPS.setPCMBitDepthLuma (g_uiPCMBitDepthLuma);
@@ -889,5 +854,5 @@
   {
     TComVUI* pcVUI = m_cSPS.getVuiParameters();
-    pcVUI->setAspectRatioInfoPresentFlag(getAspectRatioIdc() != -1);
+    pcVUI->setAspectRatioInfoPresentFlag(getAspectRatioInfoPresentFlag());
     pcVUI->setAspectRatioIdc(getAspectRatioIdc());
     pcVUI->setSarWidth(getSarWidth());
@@ -1323,17 +1288,16 @@
 Void  TEncTop::xInitPPSforTiles()
 {
-  m_cPPS.setUniformSpacingFlag( m_iUniformSpacingIdr );
-  m_cPPS.setNumColumnsMinus1( m_iNumColumnsMinus1 );
-  m_cPPS.setNumRowsMinus1( m_iNumRowsMinus1 );
-  if( m_iUniformSpacingIdr == 0 )
-  {
-    m_cPPS.setColumnWidth( m_puiColumnWidth );
-    m_cPPS.setRowHeight( m_puiRowHeight );
+  m_cPPS.setTileUniformSpacingFlag( m_tileUniformSpacingFlag );
+  m_cPPS.setNumTileColumnsMinus1( m_iNumColumnsMinus1 );
+  m_cPPS.setNumTileRowsMinus1( m_iNumRowsMinus1 );
+  if( !m_tileUniformSpacingFlag )
+  {
+    m_cPPS.setTileColumnWidth( m_tileColumnWidth );
+    m_cPPS.setTileRowHeight( m_tileRowHeight );
   }
   m_cPPS.setLoopFilterAcrossTilesEnabledFlag( m_loopFilterAcrossTilesEnabledFlag );
 
   // # substreams is "per tile" when tiles are independent.
-  if (m_iWaveFrontSynchro
-    )
+  if (m_iWaveFrontSynchro )
   {
     m_cPPS.setNumSubstreams(m_iWaveFrontSubstreams * (m_iNumColumnsMinus1+1));
@@ -1361,9 +1325,9 @@
   }
 
-  if( m_iNumColumnsMinus1 && m_iUniformSpacingIdr==0 )
+  if( m_iNumColumnsMinus1 && !m_tileUniformSpacingFlag )
   {
     for(Int i=0; i<m_iNumColumnsMinus1; i++)
     {
-      uiCummulativeColumnWidth += m_puiColumnWidth[i];
+      uiCummulativeColumnWidth += m_tileColumnWidth[i];
     }
 
@@ -1388,8 +1352,8 @@
   }
 
-  if( m_iNumRowsMinus1 && m_iUniformSpacingIdr==0 )
+  if( m_iNumRowsMinus1 && !m_tileUniformSpacingFlag )
   {
     for(Int i=0; i<m_iNumRowsMinus1; i++)
-      uiCummulativeRowHeight += m_puiRowHeight[i];
+      uiCummulativeRowHeight += m_tileRowHeight[i];
 
     if( uiCummulativeRowHeight >= iHeightInCU )
Index: trunk/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 1067)
+++ trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 1084)
@@ -80,5 +80,5 @@
   TComPicLists*           m_ivPicLists;                   ///< access to picture lists of other layers 
 #endif
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086_FIX
+#if H_3D_IC
   Int *m_aICEnableCandidate;
   Int *m_aICEnableNum;
@@ -150,5 +150,4 @@
   Void  xInitPPSforTiles  ();
   Void  xInitRPS          (Bool isFieldCoding);           ///< initialize PPS from encoder options
-#if H_MV_HLS10_GEN_FIX
 #if H_MV
 
@@ -193,5 +192,4 @@
 
 #endif
-#endif
 public:
   TEncTop();
@@ -209,7 +207,7 @@
   TComPicLists* getIvPicLists() { return m_ivPicLists; }
 #endif
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086_FIX
-  Int *getICEnableCandidate() { return m_aICEnableCandidate; }
-  Int *getICEnableNum() { return m_aICEnableNum; }
+#if H_3D_IC
+  Int*      getICEnableCandidate() { return m_aICEnableCandidate; }
+  Int*      getICEnableNum() { return m_aICEnableNum; }
 #endif
   Void      deletePicBuffer ();
@@ -272,5 +270,5 @@
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
 #endif
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086_FIX
+#if H_3D_IC
   Void                    setICEnableCandidate         ( Int* ICEnableCandidate) { m_aICEnableCandidate = ICEnableCandidate; }
   Void                    setICEnableNum         ( Int* ICEnableNum) { m_aICEnableNum = ICEnableNum; }
Index: trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp
===================================================================
--- trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp	(revision 1067)
+++ trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp	(revision 1084)
@@ -470,4 +470,9 @@
   Bool retval = true;
 
+  if ((width==0)||(height==0))
+  {
+    printf ("\nWarning: writing %d x %d luma sample output picture!", width, height);
+  }
+
   if (m_bitDepthShiftY != 0 || m_bitDepthShiftC != 0)
   {
@@ -563,4 +568,9 @@
   
   Bool retval = true;
+  
+  if ((width==0)||(height==0))
+  {
+    printf ("\nWarning: writing %d x %d luma sample output picture!", width, height);
+  }
   
   if (m_bitDepthShiftY != 0 || m_bitDepthShiftC != 0)
